//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GpsThrd.h"
#include "Gpsfunc.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall Unit1::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall GpsThrd::GpsThrd(bool CreateSuspended, void *p)
        : TThread(CreateSuspended)
{
 p_gpsfunc = reinterpret_cast<GPS_Func*> (p);
}
//---------------------------------------------------------------------------
void __fastcall GpsThrd::Execute()
{
 while(!Terminated)
 {
   WaitForSingleObject(gpsEvent, INFINITE);
   p_gpsfunc->processMsg();
 } // end of while(
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall GpsThrd::DoTerminate()
{
 
 p_gpsfunc->SetThrdStatus(true);
}