//---------------------------------------------------------------------------

#ifndef displayH
#define displayH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <stdio.h>

#include "sampthread.h"
#include "screenthread.h"
#include "Gps_interface.h"
#include "Gpsnav.h"
#include "Gpsfunc.h"



// we have two threads, one is used to collect GPS data
// the other is used to update screen;
//class SamplingThread;

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TPanel *d;
        TListView *ListView1;
        TListView *ResultListView;
        TButton *QuitButton;
        TBevel *Bevel3;
        TBevel *Bevel4;
        TLabel *Label1;
        TBevel *Bevel5;
        TBevel *Bevel6;
        TBevel *Bevel7;
        TBevel *Bevel8;
        TBevel *Bevel9;
        TBevel *Bevel10;
        TLabel *Label2;
        TBevel *Bevel11;
        TBevel *Bevel12;
        TBevel *Bevel13;
        TBevel *Bevel14;
        TLabel *Label3;
        TBevel *Bevel15;
        TBevel *Bevel16;
        TLabel *Label4;
        TBevel *Bevel17;
        TBevel *Bevel18;
        TStatusBar *StatusBar;
        TPanel *Panel2;
        TPanel *Panel3;
        TLabel *Label5;
        TLabel *Label6;
        TGroupBox *NEDPosGroupBox;
        TEdit *NED_P_LatEdit;
        TLabel *Label7;
        TEdit *NED_P_LongEdit;
        TLabel *Label8;
        TLabel *Label9;
        TEdit *NED_P_HighEdit;
        TGroupBox *ECEFPosGroupBox;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TEdit *ECEF_P_XEdit;
        TEdit *ECEF_P_YEdit;
        TEdit *ECEF_P_ZEdit;
        TGroupBox *NEDVelGroupBox;
        TLabel *Label13;
        TLabel *Label14;
        TLabel *Label15;
        TEdit *GDOP_Edit;
        TEdit *CLK_OFF_Edit;
        TEdit *VDOP_Edit;
        TGroupBox *ECEFVelGroupBox;
        TLabel *Label16;
        TLabel *Label17;
        TLabel *Label18;
        TEdit *ECEF_V_XEdit;
        TEdit *ECEF_V_YEdit;
        TEdit *ECEF_V_ZEdit;
        TBevel *Bevel1;
        TBevel *Bevel2;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall QuitButtonClick(TObject *Sender);
private:	// User declarations
     static const char* const chn_alt_str;//="ALTCHANNELMAN";
     static const char* const chprn_str;//="CHPRN";
     static const char* const almfile_str;//="ALMFILE";
     static const char* const long_str;//="LONGITUDE";
     static const char* const lat_str;//="LATITUDE";
     static const char* const alt_str;//="ALTITUDE";

     FILE *CfgFileHandle;
     bool ch_allocate_manually;
     int prn[6];
     AnsiString almFileNm;
     double llh[3];// 0--longi, 1--lati, 2--height

     const static ITEM_NUM = 13;
     const static RESULT_NUM = 9;
     TListItem *channel[CH_NUM];
     TListItem *ch_result[CH_NUM];
     IoInterface* GpsInterface;
     GPS_Nav* Gpsnav;
     GPS_Func* Gpsfunc;
     bool handleopened ;

     ScreenThread *c_thread;

public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        __fastcall ~TForm1(void);
        void update_channel(unsigned char idx, unsigned short *newdata);
        void update_allchannel(PT_allch_rawdata_disp);
        void update_trkloop(PT_channel_disp);
        void update_navresult(PT_navinfo_disp);
        void update_disp(void);
        void read_cfg(FILE*);
        GPS_Nav* get_gpsnav_pt(void);
        GPS_Func* get_gpsfunc_pt(void);
        IoInterface* get_iointerface_pt(void);
        double getlongi(void);
        void setlongi(double);
        double getlati(void);
        void setlati(double);
        double getalti(void);
        void setalti(double);
        AnsiString getalmfilenm(void);
        void setprn(FILE*, struct tm*);
        void update_gpsweek();
};
const char* const TForm1::chn_alt_str ="ALTCHANNELMAN";
const char* const TForm1::chprn_str="CHPRN";
const char* const TForm1::almfile_str="ALMFILE";
const char* const TForm1::long_str="LONGITUDE";
const char* const TForm1::lat_str="LATITUDE";
const char* const TForm1::alt_str="ALTITUDE";
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;

//---------------------------------------------------------------------------
#endif
